---
title: WebGL2RenderingContext.vertexAttribIPointer()
slug: Web/API/WebGL2RenderingContext/vertexAttribIPointer
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.vertexAttribIPointer()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> specifies integer data formats and locations of vertex attributes in a vertex attributes array.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.vertexAttribIPointer(<var>index</var>, <var>size</var>, <var>type</var>, <var>stride</var>, <var>offset</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>index</code></dt>
 <dd>A {{domxref("GLuint")}} specifying the index of the vertex attribute that is to be modified.</dd>
 <dt><code>size</code></dt>
 <dd>A {{domxref("GLint")}} specifying the number of components per vertex attribute. Must be 1, 2, 3, or 4.</dd>
 <dt><code>type</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the data type of each component in the array. Must be one of: <code>gl.BYTE</code>, <code>gl.UNSIGNED_BYTE</code>, <code>gl.SHORT</code>, <code>gl.UNSIGNED_SHORT</code>, <code>gl.INT</code>, or <code>gl.UNSIGNED_INT</code>.</dd>
 <dt><code>stride</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the offset in bytes between the beginning of consecutive vertex attributes.</dd>
 <dt><code>offset</code></dt>
 <dd>A {{domxref("GLintptr")}} specifying an offset in bytes of the first component in the vertex attribute array. Must be a multiple of <code>type</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Description">Description</h2>

<p>Very similar to {{domxref("WebGLRenderingContext.vertexAttribPointer()")}}. The main difference is that while values specified by <code>vertexAttribPointer</code> are always  interpreted as floating-point values in the shader (even if they were originally specified as integers in the buffer), this method allows specifying values which are interpreted as integers in the shader.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Linear_Blend_Skinning">Linear Blend Skinning</h3>

<pre class="brush: js, highlight: [9]">//Describe the layout of the buffer:
//1. position
gl.vertexAttribPointer(0, 3, gl.FLOAT, false, 20, 0);
gl.enableVertexAttribArray(0);
//2. bone weights, normalized to [0, 1]
gl.vertexAttribPointer(1, 4, gl.UNSIGNED_BYTE, true, 20, 12);
gl.enableVertexAttribArray(1);
//3. bone indices, interpreted as integer
gl.vertexAttribIPointer(2, 4, gl.UNSIGNED_BYTE, 20, 16);
gl.enableVertexAttribArray(2);

//Connect to attributes from the vertex shader
gl.bindAttribLocation(shaderProgram, 0, "position");
gl.bindAttribLocation(shaderProgram, 1, "boneWeights");
gl.bindAttribLocation(shaderProgram, 2, "boneIndices");
</pre>

<pre class="brush: html, highlight: [8]">&lt;script id="shader-vs" type="x-shader/x-vertex"&gt;#version 300 es

uniform mat4 mvMatrix;
uniform mat4 bones[120];

in vec3 position;
in vec4 boneWeights;
in uvec4 boneIndices;//read as 4-component unsigned integer

void main() {
    vec4 skinnedPosition =
        bones[boneIndices.s] * vec4(position, 1.0) * boneWeights.s +
        bones[boneIndices.t] * vec4(position, 1.0) * boneWeights.t +
        bones[boneIndices.p] * vec4(position, 1.0) * boneWeights.p +
        bones[boneIndices.q] * vec4(position, 1.0) * boneWeights.q;
    gl_Position = mvMatrix * skinnedPosition;
}
&lt;/script&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.8", "vertexAttribIPointer")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glVertexAttribPointer.xhtml", "glVertexAttribPointer")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.vertexAttribIPointer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.vertexAttribPointer()")}}</li>
</ul>
